defmodule Wish.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    Wish.Release.migrate()

    children = [
      WishWeb.Telemetry,
      Wish.Repo,
      {Ecto.Migrator,
       repos: Application.fetch_env!(:wish, :ecto_repos), skip: skip_migrations?()},
      {DNSCluster, query: Application.get_env(:wish, :dns_cluster_query) || :ignore},
      {Phoenix.PubSub, name: Wish.PubSub},
      # Start the Finch HTTP client for sending emails
      {Finch, name: Wish.Finch},
      # Start a worker by calling: Wish.Worker.start_link(arg)
      # {Wish.Worker, arg},
      # Start to serve requests, typically the last entry
      WishWeb.Endpoint
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: Wish.Supervisor]
    Supervisor.start_link(children, opts)
  end

  # Tell Phoenix to update the endpoint configuration
  # whenever the application is updated.
  @impl true
  def config_change(changed, _new, removed) do
    WishWeb.Endpoint.config_change(changed, removed)
    :ok
  end

  defp skip_migrations?() do
    # By default, sqlite migrations are run when using a release
    System.get_env("RELEASE_NAME") != nil
  end
end
